/*
    base and operators defining the Hilbert space
    base = spin-configurations,
    p.e. get the index from config or reverse, get symetric conf.
    - look at block_no
  
 */
#include "hilbert.h"
#include "mem.h"
#include "tbase.h"
#include "ansatz.h"
#include "array_m.h"
#ifdef CONFIG_PTHREAD
#include <pthread.h>
#endif

ULLong  npa[NN+1][NN+1][NN+1];   /* (o+u+d)!/(o!u!d!) stored as 3D table */

zahl fak(int i){zahl r=1.0;int j;for(j=2;j<=i;j++)r*=j;return(r);}
/* ------------------------------------------------------
 *  calculate the binominal coefficient (use pascal triangle(?))
 *  over(n,k) = n!/((n-k)!k!) = over(n-1,k-1)*n/k = over(n-1,k)+over(n-1,r-1)
 * --------------------------------------------------------- */
ULLong over(int n,int k){
  static ULLong pascal[2*NN+1][2*NN+1]; static int ok=0; int i,j;
  if(!ok){ ok=1;		/* de: Pascal-Dreieck bauen */
    for(i=0;i<=2*NN;i++)for(j=0;j<=2*NN;j++)pascal[i][j]=(ULLong)((j)?0l:1l);
    for(i=1;i<=2*NN;i++)for(j=1;j<=i;j++)
      pascal[i][j]=pascal[i-1][j]+pascal[i-1][j-1];	/* OVL ? */
  }  
  if(n>2*NN || k>n) return 0l;		/* NN => 2*NN  Nov98 JS */ 
  return pascal[n][k]; /* only 0<=k<=n<=NN */    
}


#if CM(1,1,0)  
/* Perm. mit Wdhlg (3 Elemente)=(o+u+d)!/(o!u!d!)=over(n-u,d)*over(n,u) */
 ULLong np(int o,int u,int d){ return(over(o+u+d,u)*over(o+d,d));}
#else	/* Produkt 2er Kombinat. (2 Elemente)=(n over u)(n over d) */
 ULLong np(int n,int u,int d){return(over(n,u)*over(n,d));}
#endif
void   paini(){ int a,b,c;
    for(a=0;a<=NN;a++)for(b=0;b<=NN;b++)
    for(c=0;c<=NN;c++)npa[a][b][c]=np(a,b,c);
    return;}
    
/* number of spin configurations (nn,nu,nd), same as n1 without Sym */
ULLong numconf(){ return(npa[nn-CM(1,1,0)*(nu+nd)][nu][nd]);}

/* --------------------------------------------------------------------*
 *                    in-out-functions
 * call this function not more than 5 times within one printf() :) 
 * .=empty-site, u=up, d=down, 3=up+down 
 * ToDo: for S>1/2 output for tJ,tU (s,m=-s...+s) and for JJ (m)=(-s...+s)
 * ------------------------------------------------------------------- */
char *ckfg(tbase ic){ /* Spinconfiguration |..43210> zB: |...u.dudu> */
    static char s1[5*(NN+1)],s2[5]=".ud3",*s3;static int x=0;int i;
    x++;x%=5;s3=s1+x*(NN+1);
    for(i=nn-1;i>=0;i--) s3[nn-1-i]=s2[ geti(ic,i) ];
    /* ic>>=32 can fail if sizeof(ic)==32, therfore we split the command */
    ic>>=1; ic>>=CM(1,2,2)*nn-1;
#ifndef B2size /* here cast (int) would not work, fix it in vlint.h */
    if (ic)
       E1("ckfg: unused bits are set! %08x",(int)ic);
#endif
    s3[nn]='\0';return((char *)s3);}

/* ----------------------------------------------------------------------- * 
 * symmetry-OP   PermOp(ip)*ib1=s*ib2 , s = +1/-1  ip = permutation vector 
 * ----------------------------------------------------------------------- */
/*   example:
 P = [0 2 1 3] = (0) (1,2) (3)
 ib1= (.. du .u d.) = sites (3 2 1 0) = bits (76 54 32 10)
 m1=7=3d -
 m1=6=3u -						 
 m1=5=2d m2=3=1d i2=(.. .. d. ..) s=0       i3=(11 11 10 00)=(0000,1110)
 m1=4=2u m2=2=1u i2=(.. .. du ..) s^=i3_1=0 i3=(00 00 01 00)=(1110,1110)
 m1=3=1d -
 m1=2=1u m2=4=2u i2=(.. .u du ..) s^=i3_3=0 i3=(11 11 01 00)=(0010,1110)
 m1=1=0d m2=1=0d i2=(.. .u du d.) s^=i3_0=0 i3=(00 00 10 10)=(0010,0001)
 m1=0=0u -      
 ------------------------------------------------------------------------ */
/* ms!=0 multiply phase with k, ToDo: remove and simplify
 * later build in FPGA!
 */
/* static inline */
void get_symconfig(tbase ib1,int ip,tbase *ib2,tphase *ss,int ms){
  tbase i2; int m1, m2;
#if CM(0,1,1)
  tbase i3; int s;
#endif
  *ib2=ib1; *ss=+1; if(ip<0) return; /* 1-Operator (0,identity) */
#if CM(0,1,1)
  i3=i2=0l; s=0;				/* remove from NN-1 to 0 */ 
  for(m1=2*nn-1;m1>=0;m1--)if((ib1>>m1)&1){	/* m1 = old index */
    m2 = sym.i[ip][m1/2]*2+(m1&1);		/* m2 = new index */
    i2 |= (tbase)1<<m2;				/* move spin to m2 */
    if (m2>0) s^=(int)(1&(i3>>(m2-1))); 	/* number of spins jumped over */ 
    i3 ^= (~(tbase)0)<<m2;		/* derived fermionic sign */
  }
  (*ss) *= 1-2*(s&1);
#else /* CM(1,0,0) Heisenberg, ToDo: make speedtests over all n1 */ 
  i2=0l;
  for (m1=0; ib1!=0 && m1<nn; m1++, ib1>>=1) if (1&ib1) { /* faster if nd<=nu */
    m2 = sym.i[ip][m1];
    i2 |= ((tbase)1) << m2;	/* Mai99 bug entfernt */
  }	/* ToDo: uebergabe &sym.i[ip] statt ip ???  */
#endif /* JJ */
  *ib2=i2;
  if(ms){
    (*ss)*=sym.w[ip];
#if VecType & 4
    /* Rundungsfehler ausgleichen, do outside */
    if(fabs(imag(*ss))<1e-9) (*ss)=C(real(*ss),0);
#endif
  }  
  return;
}

tbase m55=0;    /* dynamic initialisation only in C++ => initmasks */
tbase mAA=0;
tbase m0F=0;

/* initialize bitmasks m55,mAA,m0F */
int initmasks(int nn){
  int i; tbase r=0;
  for(i=0;(unsigned)i<sizeof(tbase)*8;i+=2) r|=((tbase)1)<<i;
  m55=r;
  mAA=r<<1;
  m0F=~(((~(tbase)0)<<(nn-1))<<1); /* (int32)<<32 won't work on x86 */
  /*  printf(" ini55: %s\n",ckfg(r)); */
  return 0;
}
    
/* ----------------------------------------------------------------------- * 
 * Symmetrienutzung   u<->d,   attention: ss may point to s1 !!!
 * ----------------------------------------------------------------------- */
/* static inline */
void get_sudconfig(tbase ib1,tphase s1,tbase *ib2,tphase *ss){
#if Sud
#if CM(0,0,1)			/* ib2(ss) can also point to ib1(s1) !!! */
  tbase1 i3;
#endif  
#endif
  *ib2=ib1;*ss=s1;		/* default */
#if Sud				/* programm */
  if(nu!=nd) return;
#if CM(1,0,0)
  (*ib2)=ib1 ^ m0F;
#else
  (*ib2)=((mAA & ib1)>>1) | ((m55 & ib1)<<1);
#if CM(0,0,1)  /* 3=(u+d) will change sign, ToDo: only if sign needed? slow */
  for (i3=((tbase)3)<<(2*nn-2); i3!=0; i3>>=2) if ((ib1&i3)==i3) (*ss)*=-1; 
#endif
#endif   
  (*ss)*=sym.wud;
#endif  /* no Sym */
  return;}

/* --------------------------------------------------------------------	*
 * 		Spin-Konfigurationen ki und deren Index i		*
 * --------------------------------------------------------------------	*/
#define MF(x)   ( ~((~(tbase)0)<<(x)))	/* << only int/long, not longlong */
#define MA(x)   (mAA & MF(x))		/* MF(x) = x * 1 bits */
#define M5(x)   (m55 & MF(x))
#define M1(x)   (  ((tbase)  1)<<(x) )
#define M2(x)   (  ((tbase)  2)<<(x) )
#define M3(x)   (  ((tbase)  3)<<(x) )
#define ME(x)   (  ((tbase)0-2)<<(x) )
#define MC(x)   (  ((tbase)0-4)<<(x) )
#if CM(0,1,0)
inline tbase next(tbase kfg){                                       /* ki++ */ 
  int i=0,d=0,u=0; 	/* Achtung: ki<<32 bei 32bit nicht definiert*/
  if(kfg&2l)d+=2; else if(kfg&1l)u+=2;
  while((i+=2)<2*nn)switch((int)((kfg>>i)&3l)){
   case 0:       if(u){ u-=2;
     return((kfg & MC(i)) | M1(i) | M5(u)<<d | MA(d));} else if(d){ d-=2;
     return((kfg & MC(i)) | M2(i) | M5(u)<<d | MA(d));} break;
   case 1: u+=2; if(d){ d-=2;
     return((kfg & MC(i)) | M2(i) | M5(u)<<d | MA(d));} break;
   case 2: d+=2;}
  return(M5(u)<<d | MA(d));}

tbase  ll1(ULLong ii){ /* getbasis from index 0..N1-1 */
  ULLong i,t;tbase j;int io,iu,id;
  j=0l;io=nn-nu-nd;iu=nu;id=nd;i=ii+1l;
  for(;;){
   if(io>0){ if(i<=(t=npa[io-1][iu][id])){j=(j<<2);  io--;continue;}i-=t;}
   if(iu>0){ if(i<=(t=npa[io][iu-1][id])){j=(j<<2)|1;iu--;continue;}i-=t;}
   if(id>0){ if(i<=(t=npa[io][iu][id-1])){j=(j<<2)|2;id--;continue;}i-=t;}
   else break;}
  return(j);}
    
ULLong ll2(tbase ii){ /* n-dimensionale Linkodierung */
/* Inp: Spinconfiguration, Out: Index des Basiszustandes */
    ULLong j=0l;int io,iu,id,i,i1;
    io=nn-nu-nd;iu=nu;id=nd;for(i=nn-1;i>=0;i--){
      i1=(int)(3&(ii>>(2*i)));
      if(i1>0 && io>0)j+=npa[io-1][iu][id];
      if(i1>1 && iu>0)j+=npa[io][iu-1][id];
      if(i1==0)io--;
      if(i1==1)iu--;
      if(i1==2)id--;}
    return(j);}

#elif CM(1,0,0)

/* 01101 i=1 d=1 inp  */
/* 01110 i=2 d=1 !!!  */
/* 10011 i=2 d=2      */
/* 10101 i=1 d=1      */
/* 10110 i=2 d=1      */
/* 12233=123=LM
   00011 002 i=2 d=1
   00101 011
   01100 020
   10001 101
   10100 110
 */
/* last change: long long Anpassung 9.4.1998 JS */
/* MP-version Dec99, better readable */
#if defined(SBase) && defined(CONFIG_S1SYM)
static inline tbase next(tbase kfg){	/* ??? */ 
  int i,d,k,j,v=0;	/* i position des ersten 01 musters */
  i=d=0;		/* d anzahl 1bits exclusive 01 muster */
  if(sym.num_lm!=nn){   /* ToDo: replace by S(+,i)-ops and s>1/2 sites */
    if(v&1)printf("\n0 i=%2d d=%2d next=%s",i,d,ckfg(kfg));
    for(;i!=nn;i++){ /* searching 01 bit pattern */
     if(1&(kfg>>i)){ /* loesche spin, wenn kein hoeheres LM */
       for(k=i+1;k<nn;k++)if(sym.lm[k]==sym.lm[i])if(1&(kfg>>k))break;
       if(k==nn)
       for(k=0  ;k<=i;k++)if(sym.lm[k]==sym.lm[i])if(1&(kfg>>k)) 
       { d++;kfg&=~M1(k); }
     }
     else { /* OVL to other LM */
       for(j=0,k=0;k<i;k++)if(sym.lm[k]==sym.lm[i])j++;
       if(d>j)break;
     }
    }
    if(i<nn) { kfg |= M1(i); d--; } else i=d;
    /* erst spins in LM verteilen */
    if(v&2)printf("\n1 i=%2d d=%2d next=%s",i,d,ckfg(kfg));
    for(k=0;k<i && d>0;k++)if(sym.lm[k]==sym.lm[i]){ d--;kfg|=M1(k); }
    /* nun der Rest */
    if(v&4)printf("\n2 i=%2d d=%2d next=%s",i,d,ckfg(kfg));
    for(k=0;k<i && d>0;k++)if(!((kfg>>k)&1)){ d--;kfg|=M1(k); }
    if(v&8)printf("\n3 i=%2d d=%2d next=%s",i,d,ckfg(kfg));
    return(kfg);
  }
  for(;i!=nn;i++){ if((kfg>>i)&1)d++;else if(d)break; }
  return ( (kfg & ~MF(i)) | M1(i) | MF(--d) ); /* d==0: x<<-1 ???  */
}
#else
static inline tbase next(tbase kfg){	/* ??? */ 
  int i,d;		/* i position des ersten 01 musters */
  i=d=0;		/* d anzahl 1bits exclusive 01 muster */
  for(;i!=nn;i++){ if((kfg>>i)&1)d++;else if(d)break; }
  return ( (kfg & ~MF(i)) | M1(i) | MF(--d) ); /* d==0: x<<-1 ???  */
}
#endif

tbase  ll1(ULLong ii){	/* getbasis from index 0..N1-1 */
    ULLong i,t;tbase j;int iu,id;
    j=0l;iu=nu;id=nd;i=ii+1l;if(nn!=nu+nd)F0("nu+nd != NN")
    for(;;){
     if(iu>0){ if(i<=(t=npa[0][iu-1][id])){j=(j<<1)|0;iu--;continue;}i-=t;}
     /* else { j=(j<<id)|MF(id);break; F A S T E R ???? } */
     if(id>0){ if(i<=(t=npa[0][iu][id-1])){j=(j<<1)|1;id--;continue;}i-=t;}
     break;}
    return(j);}
    
ULLong ll2(tbase ii){	/* n-dimensionale Linkodierung */
/* Inp: Spinconfiguration, Out: Index des Basiszustandes */
    ULLong j=0l; int iu,id,i,i1;
    iu=nu; id=nd; if(nn!=nu+nd) F0("nu+nd != NN")
    for(i=nn-1;i>=0;i--){
      i1=(int)(1&(ii>>i));
      if (i1>0 && iu>0 && id>0) j+=npa[0][iu-1][id];
      if (i1==0) iu--;
      if (i1==1) id--;}
    return(j);
}

#elif CM(0,0,1)

inline tbase next(tbase kfg){  				/* ki++ */ 
  int i,d,u;if(kfg&1l)u=2;else u=0;if(kfg&2l)d=2;else d=0;  
  for(i=2;i<2*nn;i+=2)switch((int)(3&(kfg>>i))){      /* -1<<2=-4 */
   case 0:
    if(u){ return((kfg & MC(i)) | M1(i) | M5(u-2) | MA(d));} else 
    if(d){ return((kfg & MC(i)) | M2(i) | M5(u) | MA(d-2));} break;
   case 1:  u+=2; 
    if(d){ return((kfg & MC(i)) | M2(i) | M5(u) | MA(d-2));} break;
   case 2:
    if(u){ return((kfg & MC(i)) | M3(i) | M5(u-2) | MA(d));} d+=2; break;
   case 3:  u+=2;d+=2;}
  return( M5(u) | MA(d) );}

tbase  ll1(ULLong ii){	/* get configuration from index 0..N1-1 */
    tbase j;int in,iu,id;ULLong i,t;i=ii;j=0l;iu=nu;id=nd;
    for(in=nn-1;in>=0;in--){
     if(in>=iu && in>=id){
         if(i<(t=npa[in][iu  ][id  ])){continue;}i-=t;}
     if(iu>0 && in>=id){
         if(i<(t=npa[in][iu-1][id  ])){j|=M1(2*in);iu--;continue;}i-=t;}
     if(id>0 && in>=iu){
         if(i<(t=npa[in][iu  ][id-1])){j|=M2(2*in);id--;continue;}i-=t;}
     if(id>0 && iu>0)
         if(i<   npa[in][iu-1][id-1] ){j|=M3(2*in);id--;iu--;continue;}
     break;}
    return(j);}
    
ULLong ll2(tbase ii){                /* ki -> i */
    ULLong j;int iu,id,i,i1;j=0l;iu=nu;id=nd;
    for(i=nn-1;i;i--){ if(i<iu)if(i<id)break;i1=3&(ii>>(i<<1));
      if(i1>0){  if(i>=iu   && i>=id        )j+=npa[i][iu  ][id];
       if(i1>1){ if(i>=iu-1 && i>=id && iu>0)j+=npa[i][iu-1][id];id--;
        if(i1>2){if(i>=iu   && i>=id        )j+=npa[i][iu  ][id];iu--;}}
       else iu--;}}
    return(j);}
#endif
#undef MF
#undef MA
#undef M5
#undef M1
#undef M2
#undef M3
#undef MC
#undef ME

/* suche entry in sorted tab[0..l-1], not found => 0 */
/* ToDo: it should be easier with uuu and ddd-tab if tU */
ULong findkfg(tbase entry, ULong l){
  ULong j,m;j=0l;  /* v203 tbase1=>ULong, 98: ULong=>tbase1 */
#if (CM(1,2,2)*NN-1)>8*S_long-1
  m=~(~(ULong)0u>>1);		/* set msb (highest bit) */
#else
  m=((ULong)1)<<(CM(1,2,2)*nn-1);
  if(m==0 || m==1)F0("OVL");
#endif
  while(m){if((j|m)<l)	/* long unsigned == unsigned long ? */
    if(getl1(j|m)<=entry) j|=m;
    m>>=1;
  }
  /* if(getl1(j)!=entry)j=0l;			 not found */
  return((ULong) j);			/* ULong/tbase1 ??? */
}

/* ------------------------ Symmetrische Basis (class base) ---- *
 * inp: sym.k[], sym.i[] 
 * out: |rc)=sign(s)*|s|^(-1/2)*|rc],  s=<ib1|rc)
 * |] is sym-base, summe aller zu |ib1> symmetr. configs 
 * |) is normed sym-base, 
 * |> is spin-configuration (1st base) 
 * ------------------------------------------------------------- */
 
/* is=0 nicht storen! bzw. hinten, is!=0 nach vorn, .num kleiner nj */


/* b->o: 0=getbase     sign,norm2,skfg,num,ib[],is[] ok
 *       1=smallest    sign,norm2,skfg ok ???
 *       2=ifsmallest  sign,skfg if(smallest)(norm2) ok, num=0
 */
int b_out(struct sbase *b,int len){	/* JS Mai99, bug: b to *b Nov99 */
  int i;if(len==0)len=b->num;
  printf("\n sign=%s norm2=%4g num=%4d o=%d skfg=%s",
    outphase(b->sign),(double)b->norm2,b->num,b->o,ckfg(b->skfg));
  for(i=0;i<len && i<b->num;i++) 
    printf("\n%3d %s %s",i,outphase(b->is[i]),ckfg(b->ib[i]));
  return 0;
}

#if VecType & 4		/* used in b_getbase... */
#define ABS1(x) ((int)(fabs(x)+.5))
#else
#define ABS1(x) abs(x)
#endif

/* --- ax|vx>+...+1|vx> => (ax+1)|vx>+...+0|vx> --- ib[num] already stored */
/* 0-entries durch (b.num-1)-entries ersetzen und b.num-- (packen) ???? 
 * gleiche kfg-entrys mit verschiedenen signen interferieren zu 0! 
 * twice ist 0, wenn der mutterfunktion der Faktor twice bekannt ist
 *    kann die Neuberechnung gespart werden
 */
void b_twice(struct sbase *b,int twice){  
  int k,j,num/* ,t */;
  if(twice==0)
  for(num=0;num<b->num;num++) if (b->ib[num]==b->skfg) twice++;
  if(b->o!=2 && twice>1)
  for(num=0;num<b->num;num++) if (ABS1(b->is[num])) {
    for(k=num+1,j=twice;k<b->num && j>0;) if (b->ib[k]==b->ib[num]) {
      b->num--;j--;
      b->is[k]=b->is[b->num];		/* tabelle kuerzen */
      b->ib[k]=b->ib[b->num];
    } else k++; /* Jan03: "else" correct? new {} */
  }
  b->norm2=b->num;
  return;
}

/* ---- get_lm_factor ---- (long64: 2^64=1.845e19)
 * N=6 s=14 s*N=84 sym=12 spin-chain, J1=J2=1
 *   u=18,d=66: ns=1e18 n1= 2888 n2max=2e16 E0=-15   2s,8s (fits to 64bit)
 *   u=20,d=64: ns=1e19 n1= 4440 n2max=1e17 E0=-62         (ERR9112 k=0)
 *   u=22,d=62: ns=9e19 n1= 6500 n2max=1e18 E0=-105  3s,19s
 *   u=24,d=60: ns=2e19 n1= 9097 n2max=9e18 E0=-144  4s,26s
 *   u=26,d=58: ns=1e19 n1=12208 n2max=2e19 E0=-179  5s,35s
 *   u=42,d=42: ns=2e19 n1=17052 n2max=2e22 E0=-309 i70=169s
 * Tnorm2 is ULLong per default, but can be set to double for big-s systems
 */
Tnorm2 b_factor_lm(tbase ib1){  
  int k,b1,i1,obj[NN][4]; /* 0,1,2,3 for empty,up,down,up+down sites */
  Tnorm2 n2,factor;
  n2=1;	
  if(sym.num_lm==nn) return(n2);
  /* compute factor (n1+n2+n3+n4)!/(n1!n2!n3!n4!) =
   *   = (n1+n2+n3+n4)!/n1! * (n2+n3+n4)!/n2! * (n3+n4)!/n3!
   *  where n1=number_of_empty_sites, n2=number_of_ups, ... per LM-spin
   */
  for(k=0;k<nn;k++){ obj[k][0]=obj[k][1]=obj[k][2]=obj[k][3]=0; } 
  for(i1=0;i1<nn;i1++){  /* count types of sites n1,..,n4 */
      b1=geti(ib1,i1); obj[sym.lm[i1]][b1]++;
  }
  for(k=0;k<nn;k++)if(sym.lm[k]==k){
      factor=over(obj[k][0]+obj[k][1]+obj[k][2]+obj[k][3],obj[k][3])
            *over(obj[k][0]+obj[k][1]+obj[k][2]          ,obj[k][2])
            *over(obj[k][0]+obj[k][1]                    ,obj[k][1]);
      if( (double)(n2*factor) != n2*(double)factor ) ERR(9110);
      n2*=factor;
  }
  return(n2);
}

/* ----------------------------------------------------------------------- */
#define Err17 {static int e0=1;if(e0){ E0("b_*_lm may be buggy! check with NOS1SYM!"); e0=0;}}

/*  effect of 2-site-LM-symmetry for tU-model considering fermionic sign (Feb04)
 *      .. => +..              .3 => +3.           33 => +33
 *      .u => +u.*parity       ud => -du
 *      uu => -uu vanished     u3 => +3u*parity
 *   LM = c(+,p[i])c(+,p[j])c(-,j)c(-,i)              */
/* Feb04: rewritten
   ToDo: test S=5/2 N=6 16+14 nk=1.5e8 sym=4 n1=1091 33s until 2S=
       does not work for LM, tU u2d0 N=8 square
   oo=0: return full expanded base (all symmetric configs)
   oo=1: return smallest + sign + norm2 (dont extend base)
   oo=2: break, if sign==0 or smaller found (like ifsmallest)
   ToDo: better return was_smallest/got_smallest/0?
 */
tbase b_getbase_lm(struct sbase *b, int oo){  
  tbase ib0,ib2; int j,b1,b2,i1,i2,n2; tphase s0,s1,s2;
  CM({},Err17,Err17)	/* signum ??? */
  n2=0;	/* count same lm-skfgs */
  /* b->num must be greater than 0 (one argument or more) */
  b->sign=b->is[0]; b->skfg=b->ib[0]; /* if we have n2==1 */
  for(j=0;(ULLong)j<(ULLong)b->num;j++){
   ib0=b->ib[j]; s0=s1=b->is[j];	/* check next config */
   if(s0==0) E0("Warning: sign[j]=0");
   if (ib0< b->skfg) { b->skfg=ib0; b->sign=s0; n2=1; }
   /* ib0 = original (smallest?), ib2 = new_lm_cfg */
   for(i1=0;i1<nn-1;i1++)for(i2=i1+1;i2<nn;i2++)if(sym.lm[i1]==sym.lm[i2]) {
     b1=geti(ib0,i1); /* site 1 within LM-site */
     b2=geti(ib0,i2); /* site 2 within LM-site */
     if(b1!=b2){ /* exchange sym-sites */
       ib2=puti(puti(ib0,i1,b2),i2,b1); s2=s1;
       /* tU,tJ fermionic sign change? call (2sites) permutation function? */
#if CM(0,1,1)
       if (zi(ib0,i1)+zi(ib0,i2)!=0) { /* examples: .u u3 (fermionic transfer) */
         s2=s1*parity(ib0 & p_mask[i1][i2]); }  /* not coding independent */
       if (zizj(ib0,i1,i2)!=0){ s2=-s1; }      /* ud (fermionic exchange) */
#endif
       if(b->skfg==ib2){	/* same lm-symmetric config stored */
         if(!phase_eq(s2,b->sign)){
         b->sign=0; b->num=0; b->norm2=0; return TBASE0;}
       }
       if(!(ib0<=ib2)){ b->ib[j]=ib0=ib2; b->is[j]=s0=s2;
         if(!(b->skfg<=ib0)){
           b->skfg=ib0; b->sign=s0; n2=0; if(oo==2) return ib2; }
         i1=i2=nn; j--; /* restart for this config */ break;
       }
     }
#if CM(0,1,1)
     else {  /* b1==b2 */
       if (abs(zi(ib0,i1))>0 /* && abs(zi(ib0,i2))>0 */){
         b->sign=0; b->num=0; b->norm2=0; return TBASE0; } /* uu + -uu */
     }
#endif
   }
   /* add factor_lm new lm-symmetric configs to table *slow!* */
   if (oo==0) { Err17; } /* not supported yet, we should not need it */
  }
  /* calculation of n2 is buggy, so we reat it here */
  for(n2=j=0;(ULLong)j<(ULLong)b->num;j++){
   if (b->ib[j]==b->skfg) n2++; /* how often is skfg stored within table */
  }
  if(oo<2){	/* (n1+n2+n3+n4)!/(n1!n2!n3!n4!) */
    Tnorm2 factor=b_factor_lm(b->skfg);
    b->norm2=b->num*factor/(unsigned)n2; /* ULLong -> int ??? */
    if( (double)(b->num*factor/n2) != b->num*(double)factor/n2 ) ERR(9111);
  }
/* printf("\n dbg3: %s o=%d n2= %d norm2= %d bnum %d",ckfg(b->skfg),oo,(int)n2,(int)b->norm2,(int)b->num); */
  if(!b->norm2) b->sign=(tphase)0;
  return(b->skfg);
}

/* erzeugt nur kleinere Konfiguration wenn erstes bit in sbase=1 CM(JJ) */
void b_getbase_ud(struct sbase *b){  /* bei Sz!=0 Verschwendung! */
  tbase ib0,ib1,ib2;int i,j,nj; tphase s1;
  j=nj=b->num;ib0=b->skfg;ib1=b->ib[0];
  for(i=0;i<nj;i++)/* if(b->is[i]!=0) */{
    get_sudconfig(b->ib[i],b->is[i],&ib2,&s1);	/* s|ib2>=T|ib1> */
    if(!(ib0<=ib2)){b->skfg=ib0=ib2;b->sign=s1;if(b->o==2)return; }
    if( (ib1==ib2)){
      if(!phase_eq(s1,b->is[0])){b->sign=0;b->num=0;return;}
      j=nj;break; /* wegen |symkfg>=Tud|symkfg> Jan00 */
    }
    b->ib[j]=ib2; b->is[j]=s1; j++;
  }
  b->norm2=b->num=j; return;
}

/* ---- long=+uudd+uudd -> short=2uudd+0uudd ---- */
/* faster, if symconfig and sudconfig called one after another? */
/* kuerzen als extra-funktion ??? redundanter code .._lm */
/* better save index for smallest? (temporarly) SORTING??? */
/* create cache??? or create only different configs */
/* n1_sym is ca. n1/sym, d.h. ib1==ib2 | twice>1 is rare -> faster? */
tbase b_getbase(tbase ib1,struct sbase *b){  
  tbase ib0,ib2; int j,n2,nj=sym.numall+1; tphase s1;
  b->ib[0]=b->skfg=ib0=ib1; b->is[0]=b->sign=1; n2=1;
  if(nj*((nu==nd)?2:1)>MaxSBase)F0("MaxSBase-OVL, enlarge it!?");
  for(j=1;j<nj;){ s1=1;
    get_symconfig(ib1,((unsigned)j)-1,&ib2,&s1,1);
    if(!(ib0<=ib2)){b->skfg=ib0=ib2;b->sign=s1;if(b->o==2)return ib2;}
    if( (ib1==ib2)){
      if(!phase_eq(s1,1)){b->sign=0;b->num=0;return ib2;} n2++; }
    b->ib[j]=ib2; b->is[j]=s1;
    j++;
  }
  b->num=nj; b->norm2=nj*n2; if(n2>1) b_twice(b,n2);
  if(nu==nd) b_getbase_ud(b);
#if defined(CONFIG_S1SYM)    /* ToDo: does not work at the moment for tU JJ? */
  /* b_out(b,b->num); */
  if(sym.num_lm!=nn) b_getbase_lm(b,2);
  /* b_out(b,b->num); */
#endif
  return(b->skfg);}

/* ACHTUNG bei is[smallestkfg]=0 !!! sign von ib1 */           
/* 1=true 0=false, ud-test nur sinnvoll wenn erste spin=d!!!faster since Jan00 */
int b_ifsmallest(tbase ib1, struct sbase *b){ 
  int old_o;
  old_o=b->o;b->o=2; b_getbase(ib1,b); b->o=old_o;
  /* printf("\nkfg=%s: ",ckfg(ib1));b_out(b,0); */
  if((!(ib1==b->skfg)) || b->norm2==0 || phase_eq(b->sign,0)) return 0;
  b->sign=1; b->num=0;				/* not given here */
  return 1;}


/*  effect of 2-site-LM-symmetry for tU-model considering fermionic sign (Feb04)
 *      .. => +..              .3 => +3.           33 => +33
 *      .u => +u.*parity       ud => -du
 *      uu => -uu vanished     u3 => +3u*parity
 *   LM = c(+,p[i])c(+,p[j])c(-,j)c(-,i)
 *  v2.21 using sym.lnext N=8 s=10/2 nud=17+10 20s(43%) => 3s(9%) PM600MHz-pg
 */
int b_ifsmallest_lm(tbase ib0){
  int i1,i2; CM({},Err17,Err17)
  for(i1=0;i1<nn-1;i1++) { i2=sym.ln[i1];
     if(i2<nn) {  /* compare member of composed spin with next member */  
      if (geti(ib0,i1)< geti(ib0,i2)) return 0;
#if CM(0,1,1) /* (+uu) + (-uu) */
      if (geti(ib0,i1)==geti(ib0,i2) && abs(zi(ib0,i1))>0) return 0;
#endif
    }
  }
  return 1;
}

/* calculate smallest lm! (enough for smallest)
   ToDo: hard code this part or examine only lm arround changed spins
      ns*(ns+1)/2 => ns, or lm*H as optimized C++ Operator
      or lm sorted Index (proof only idx-neighbours) or lm-table
 *  v2.21 using sym.lnext N=8 s=10/2 nud=17+10 7s(25%) => 4s(17%) PM600MHz-pg
 */
tbase b_smallest_lm(tbase ib0, tphase *s1){  
  int b1,b2,i1,i2;
  CM({},Err17,Err17)	/* signum ??? */
  if (s1) ;             /* dummy access, avoiding cc warnings */
  for(i1=0;i1<nn-1;i1++) { /* l1=sym.lm[i1]; */
    b1=geti(ib0,i1); if (b1<CM(2,3,4)) { 
     for(i2=sym.ln[i1];i2<nn;i2=sym.ln[i2]) /* if(l1==sym.lm[i2]) */ {
        b2=geti(ib0,i2);
        if (b1<b2) {
          ib0=puti(puti(ib0,i1,b2),i2,b1); b1=b2; /* exchange sym-sites */
#if CM(0,1,1)
          if (zi(ib0,i1)+zi(ib0,i2)!=0) /* examples: .u u3 (fermionic transfer) */ 
            *s1*=parity(ib0 & p_mask[i1][i2]);  /* not coding independent */
          if (zizj(ib0,i1,i2)!=0) *s1=-*s1;       /* ud (fermionic exchange) */
        }
        {
          if (b1==b2 && abs(zi(ib0,i1))>0){
            *s1=0; return ib0; } /* uu + -uu */
#endif
        }
      }
    }
  }
  return(ib0);
}

/* ToDo: replace by b_smallest/b_getbase + b->o=2 */ 
/* 1=true 0=false, runs twice as fast, as the old variant */
int b_ifsmallest3(tbase ib1, struct sbase *b){ 
  t_sites k1[NN],k2[NN],*k3,i2; int i,j,n2,d;  tphase s1,s2,s3;
  t_sites *ps;    tbase ib2;
  b->sign=0; n2=1; s2=+1;
  if(nu==nd) get_sudconfig(ib1,+1,&ib2,&s2);	/* s|ib2>=T|ib1> */
#if defined(CONFIG_S1SYM) /* return b_ifsmallest(ib1,b); */
  if(sym.num_lm!=nn) {
#if 0 /* which is faster?  N=8*(s=5/2) ns=17s/600MHz */
    b->num=1;b->norm2=1;b->ib[0]=ib1;b->is[0]=1;b->sign=1;
    if (!b_getbase_lm(b,0)) return 0;
    b->num=1;b->norm2=1;b->ib[0]=ib2;b->is[0]=s2;b->sign=s2;
    if(nu==nd) { b_getbase_lm(b,1); /* get smallest */ 
                 ib2=b->skfg; s2=b->sign; if (s2==0) return 0; }
#else /* N=8*(s=5/2) ns=3s/600MHz */
    if( !b_ifsmallest_lm(ib1) ) return 0; /* never hits!? */
    if(nu==nd) {
       ib2=b_smallest_lm(ib2,&s2); if(s2==0) return 0; } /* fermionic sign ??? */
#endif
  }
#endif
  if(nu==nd){
    if(!(ib1<=ib2)){ return 0;}
    if( (ib1==ib2)){
      if(s2!=1){ return 0; }
      n2=Sud+1; 
    }
    for(i=0;i<nn;i++) k2[i]=geti(ib2,i);
  } else ib2=ib1;
  for(i=0;i<nn;i++) k1[i]=geti(ib1,i);  /* 30% CPU */
  for(i2=0,k3=k1,s3=1;;i2++,k3=k2,s3=s2){  /* ud=+1,-1 */
    for(j=0;j<sym.numall;j++){
      for(ps=&sym.i[ j ][i=nn-1];;){	/* Tj, high -> low */
        if((d=k1[i]-k3[*(ps--)])<0) break;  /* 40% CPU */
        if(d!=0) { return 0; }
        if((--i)>=0) continue;
#if CM(1,0,0)  /* signum is not cfg-dependend */
        s1=sym.w[j];			/* T|x>=t|x> same config */
#elif CM(0,1,1)  /* signum is cfg-dependend */
        tbase ib4; s1=1;
        get_symconfig(((i2)?ib2:ib1),j,&ib4,&s1,1);
#endif
        if(!phase_eq(s1*s3,1)) {
          return 0;
        }
        n2++; break;
      }
    }
    if(nu!=nd || i2>=Sud) break; /* Sep00 */
    IFww( break; )
  }
  b->skfg=ib1;b->sign=1;b->num=0; /* not given here */
  b->norm2=(((nu==nd)?Sud+1:1)*(sym.numall+1))/n2; /* OK ??? */
#ifdef CONFIG_S1SYM
  { Tnorm2 factor=b_factor_lm(ib1); /* check for 64bit overflow */
    if( (double)(b->norm2*factor) != b->norm2*(double)factor ) ERR(9112);
    b->norm2*=factor;	/* Ok ??? */
  }
#endif
  /* b_out(b,0); */
  return 1;}


/* --- last change 1998-169 JS --- */
/* static inline */ /* needed in spins.h -> xval.c */
/*
   k1 - config ib1
   k2 - config ib1 or ist ud-symmetric one
   ks - smallest config found actually 
 */
tbase b_smallest(tbase ib1, struct sbase *b){ /* about 63% CPU -O1 10+10 */
  t_sites k1[NN],k2[NN],ks[NN],*k3,i2; int i,j,n2,d; tphase s1,s2,s3;
  tbase ib2,ib3;
  b->sign=1;  b->skfg=ib1; b->norm2=1;	/* default minimum */
  n2=1;get_sudconfig(ib1,+1,&ib2,&s2);	/* s|ib2>=T|ib1> */
#if CM(0,1,1)   /* v2.0.2++ ToDo: get fast tJ8u1d2e1 running ??? */
  { b->o=1;b_getbase(ib1,b);b->o=0; return(b->skfg); } /* wont work for LM */
#endif
#if defined(CONFIG_S1SYM)
#if 0   /* v1.7.15++ */
  if(sym.num_lm!=nn){ b->o=1;b_getbase(ib1,b);b->o=0;
                      if (b->norm2==0) return(b->skfg);}
#else
  if(sym.num_lm!=nn){ 
                      b->skfg=ib1=b_smallest_lm(ib1,&(b->sign));
                      if (nu==nd) ib2=b_smallest_lm(ib2,&s2);
                      if (s2==0 || b->sign==0){ b->sign=0; return TBASE0; }
                      b->norm2*=b_factor_lm(ib1); /* fermionic sign? */
                    }
#endif
#endif
  if( nu==nd ){
    if((ib2==ib1)){
     n2=Sud+1; /* Sud (spin inversion) is 0 (not used) or 1 (used) */
     if(s2!=1){ b->sign=0; return TBASE0;}	/* s1!=1 */
    }
    if(!(ib1<=ib2)){ 
     ib3=ib1;b->skfg=ib1=ib2;ib2=ib3; b->sign=s2;s2=1; }	/* new minimum */
  }
  for(i=0;i<nn;i++){ ks[i]=k1[i]=geti(ib1,i); k2[i]=geti(ib2,i); }
  for(i2=0,k3=k1,s3=b->sign,ib3=ib1;;i2++,k3=k2,s3=s2,ib3=ib2){  /* ud=+1,-1 */
    /* search for smallest symmetric config as representator */
    for(j=0;j<sym.numall;j++){		/* take a SymOp=PermOp(j)=ps */
      for(i=nn-1;;i--){                 /* Tj, high -> low */
        /* cach miss? -> no, its accessed ca. 780 times per call */
        /* ToDo: check only occupied sites? or use hash tables */
        d=ks[i]-k3[ sym.i[j][i] ];  /* compare kfg with SymOp*kfg */
        /* sq.32+8: performance counter = 780(+/-300) (max=160*40=6400) */
        /* sq.40: 12 different pair correlations */
        if(d==0 && i!=0) continue;   /* equal Sym(cfg) else Smaller */
        /* sq.32+8: performance counter = 159(+/-1) */
        if(d<0) break;              /* greater Sym(cfg), 50% CPU v2.17 */
        /* sq.32+8: performance counter = 2(+/-1) */
#if     CM(1,0,0)  /* signum is not cfg-dependend */
        s1=sym.w[ j ]; 
#elif   CM(0,1,1)  /* signum is cfg-dependend */
        tbase ib4; get_symconfig(ib3,j,&ib4,&s1,1);
#endif
        if(d!=0) { 
          for(;i>=0;i--) ks[i]=k3[ sym.i[j][i] ]; /* store smaller config */
          n2=1; b->sign=s1*s3; break; /* found smaller kfg */
        }
        /* get same config: S|k> to s|k> */
        if(!phase_eq(s1*s3,b->sign)){b->sign=0;return TBASE0;} /* but other phase */
        n2++; break;
      } /* next site */
    }   /* test next sym */
    if(nu!=nd || i2>=Sud) break; /* Sep00 */
    IFww( break );
  }     /* test ud-sym */
  encode_ud( &(b->skfg), ks, nn);
  b->num=0;				/* not given here */
  b->norm2*=(((nu==nd)?Sud+1:1)*(sym.numall+1))/n2; /* Ok? Sud is 0 or 1 */
  /* if(norm2) b->norm2=(unsigned Tnorm2)norm2[b2i(b->skfg)]; */
  return b->skfg;
}


#define BLOCKS	8	/* can be only 2^n=1,2,4,8,etc */
/* version 0.1 Feb 2000 first try version, not finaly, for checks 
 * ideal way for part l1 into blocks => multi processing
 * in ideal case fast and invariant against symmetry operations 
 * min=0 max=n*(n-1)/2 ??? besser mit Untergittern
 */
int block_no(tbase ib1){ /* use pair correlations, count d-d pairs */
  int no,i1,i2; no=0;
  for(i1=0;i1<nn;i1++) if (zi(ib1,i1)==-1) /* nn+nd*nn Ops */
  for(i2=0;i2<nn;i2++) if (zi(ib1,i2)==+1)
   no+=sym.korr[i2][i1];
  return (no>>1)&(BLOCKS-1);
} 

ULong block_len[BLOCKS];

/* ----------------------------
 *  v1.7.13+ new ansatz, rekursiv addition of down-spins (S-(i)=Op_lowerS(i))
 *    only for non-symmetric configs
 *    does only work for full symmetry and k=0
 * ideas:
 * use array of spin-lengths spinS[]
 * use array of spin-state spinM[] ini=uuu...uuu=vacuum_state=0
 *  pack_base int[] => int and store packed
 * sample chain: 
 *   1)           uuuuuu
 *       ......
 *   2)  S-(4) -> uduuuu  (begin filling with S-(i) from (N-1) to (0))
 *           - check that we have lowest symmetric state for (N-1) to (i)
 * or use ww-matrix as hamiltonian and take next higher |i> from H|j>
 */
#if CM(1,0,0)
ULLong numsymconfJJ(int posd, int numd, tbase kfg1, int vv){
  struct sbase b; int i,iu,id; static int dd=0; ULLong num=0l;
  if( numd<=0 ){
  //    if ( vv&1 ){ printf(" %s\n",ckfg(kfg1)); }
   if(b_ifsmallest3(kfg1,&b))	/* nu,nd incorrect? */
     return 1l;
   return 0;
  }
  for(i=posd-1;i>=0;i--){
    kfg1|=((tbase)1)<<i; iu=nu; id=nd; dd++; nd=dd; nu=nn-nd;
    printf(" %s posd=%2d posd=%2d nd=%2d\n",ckfg(kfg1),posd,numd,nd);
 //   if(b_ifsmallest3(kfg1,&b))	/* nu,nd incorrect? */
    int k,j; // sorting out non-symbase configs as early as possible
     for(k=0;k<sym.numsym;k++) for(j=NN-1;j>=i;j--)
       if( sym.i[k][j]>=i ) { /* only check if P(i) is already set */
         if ((1&kfg1>>j)>(1&kfg1>>(sym.i[k][j]))) break;
         if ((1&kfg1>>j)<(1&kfg1>>(sym.i[k][j]))) goto l_skip;
     }
    /* within smallest class */
     num+=numsymconfJJ( i, numd-1, kfg1, vv );
  l_skip:
    kfg1^=((tbase)1)<<i; nu=iu; nd=id; dd--;
  }
  return num;  /* liefert genau n1/2 ??? sortierung? */
}
#endif

/* --- all what be needed for pthreads of numsymconf --- */
typedef struct sp_ns {
#ifdef CONFIG_PTHREAD
  pthread_t pt;
#endif
  int block;        /* block nr (thread nr) for debugging/timing */
  ULLong i1,n;      /* idx of configuration */
  ULLong i2,numans; /* counter */
  Tnorm2 norm2;     /* check sum */
  tbase ib1;        /* spin-configuration */
  struct sbase b;   /* working buffer (big) */
  struct sp_ns *next; /* pointer to next data set */
  unsigned char *l1p; /* pointer to part of l1-table */
  ULLong l1s,l1l;     /* l1-stored, l1-len */
  minfo_t mi;
} tp_ns;

/* void-function for pthreads */
void ns_thread( void *ptr ){
    tp_ns *p=(tp_ns *)ptr;
    tbase ibold;
    for( ibold = p->ib1 = ll1(p->i1); p->i1 < p->n; ){
#ifdef CONFIG_ANSATZ
      if(!ansatz_test(p->ib1)) p->numans++; else
#endif
      if(b_ifsmallest3(p->ib1,&(p->b))){
        p->i2++; p->norm2+=p->b.norm2;
        if (p->l1s >= p->l1l) {                 /* enlarge buffer */
          p->l1l+=64*1024; 
          p->l1p=(unsigned char *)myremalloc((void *)p->l1p,p->l1l*Bsize,&(p->mi));
          if (!p->l1p) ERR(9011); /* ToDo: myrealloc incl. fallback to mmap */
        }
        putl1(p->l1s,p->ib1,p->l1p); p->l1s++;  /* store minkfg */
        if(vvv&4)block_len[block_no(p->ib1)]++; /* ??? for future use */
      }
      p->i1++;
      p->ib1=next(p->ib1);        /* next higher config */
      if (p->ib1<=ibold) break; /* avoid overrun */
      ibold=p->ib1;
    }
    printf(" ok%d",p->block);
}


/* number of (symmetric) base-states(NN,nu,nd) -> n1_using_Sym 
 *  global vars: sym,nu,nd!
 * until v2.19:
 *   dividing in equal blocks for threads is unbalanced (2/3 only one cpu)
 *   because 1st thread has more work as the others (3 times more)
 * ToDo: better thread-balance
 *   1) create nt=4 threads, set results=0
 *      pthread_mutex_t mutex1 = PTHREAD_MUTEX_INITIALIZER;
 *      better pthread_mutex_init(&mutex1,NULL)
 *   2) pthread_mutex_lock (only one thread can pass)  (OMP_critical)
 *   3) store results, reset results, get new work=block(ns/(16*nt)) (serialized)
 *   4) pthread_mutex_unlock
 *   5) does the job and return to (2) -or- leave if work=0
 *   ... (MPI_Barrier, OMP_barrier)
 *   6) destroy threads
 *   
 */
ULLong numsymconf(){
#if defined(SBase) && (Sym+Sud>0)
  ULLong i1,i2,i3,i5,numans; Tnorm2 sum;
  tp_ns pns,*ppns,*p2; int ii,i4;
  STKa("numsymconf",(unsigned long *)&(pns.i1));
  p2=NULL ; /* dummy access, avoiding cc warnings */
#if 0
  numans = numsymconfJJ(nn,nd,(tbase)0,((nd<4 && vvv)?1:0));
  if(vvv) printf(" num_kfgJJ=%8lu %s\n",(unsigned long)numans,sclock(~0l));
#endif
  for(ii=0;ii<BLOCKS;ii++)block_len[ii]=0l;
  ppns=&pns; i4=1; i3=numconf();
  if(vvv&1)printf(" numsymconf(%.15g)",(double)i3);
#if Sud && CM(1,0,0)
  if( nu==nd && sym.num_lm==nn ) i3/=2; /* ??? does not work for LM<NN */
#endif                  
  if( sym.num_lm==nn ) i4=B_NUM;	/* blocks for i4=B_NUM threads */
  i5=0l;                                /* i5 = pointer to next block */
  if (sym.num_lm!=nn) { i4=1; }         /* avoid a bug (s=1,JJ) */
  numans=i2=0; sum=0; /* b.o 2=ifsmallest,1=smallest,0=fullbase */
  for( ii=0; ii<i4; ii++ ){ if(!ppns)ERR(9011);
    ppns->block=ii;                           /* block number */
    ppns->i1=i5;                              /* start block */
    ppns->n=((ii+1<i4)?i5+(i3>>(i4-ii-1)):i3);    /* end block (propto 2^ii) */
    if (ppns->n > i3) ppns->n=i3;
    i5=ppns->n;                               /* start next block */
    ppns->i2=0; ppns->norm2=0; ppns->numans=0; ppns->b.o=2;
    ppns->l1p=NULL; ppns->l1s=0; ppns->l1l=0;
    ppns->mi.p=NULL;  ppns->mi.l=0; ppns->mi.mode=8+1; /* remove mapfile */
    sprintf(ppns->mi.name,"tmp/l1_%03d.tmp",ii);  ppns->mi.ff=NULL;
#ifdef CONFIG_PTHREAD
    parallel_start(ii, ns_thread, ppns);
    if( ii<i4-1 ) ppns->next = (tp_ns *) malloc(sizeof(tp_ns));
    ppns=ppns->next;
  }
  if(vvv)printf(" join threads");   /* easier to debug */
  for( ppns=&pns,ii=0; ii<i4; ii++ ){
    parallel_wait(ii);
    i2+=ppns->i2; sum+=ppns->norm2; numans+=ppns->numans;
    save_l1(ppns->l1p,ppns->l1s,i2-ppns->i2);    
    myfree(ppns->l1p,&(ppns->mi));
    p2=ppns; ppns=ppns->next; if( ii>0 ) free(p2);
#else
    ns_thread( ppns );
    i2+=ppns->i2; sum+=ppns->norm2; numans+=ppns->numans;
    save_l1(ppns->l1p,ppns->l1s,i2-ppns->i2);    
    myfree(ppns->l1p,&(ppns->mi)); p2=ppns;
#endif
  }
  if(vvv&1){
    printf(" n1= %.15g n_ans= %.15g sum_n2= %.15g %s",
      (double)i2,(double)numans,(double)sum,sclock(~0l));
    if(sum!=i3) printf(" sum!=i3");
  }
  if(vvv&4)for(i1=0;i1<BLOCKS;i1++) printf("\n block_len[%2d]=%lu",(int)i1,block_len[i1]);
  STKe();return(i2);}
#else
  ULLong i1,numans=0,i2=numconf(); tbase ib1; minfo_t mi;
  if (!l1) {
    fl1=fopen(FILE_l1,"r+b");
    if(!fl1)fl1=fopen(FILE_l1,"w+b"); if(!fl1) F1("fopen %s",FILE_l1);
    l1 = (unsigned char *) mymap(FILE_l1,fl1,(long)i2*Bsize,0);           
  }
  for( ib1 = ll1(i1=0l); i1 < i2; i1++,ib1=next(ib1)){
#ifdef CONFIG_ANSATZ
      if(!ansatz_test(ib1)) numans++; else
#endif
      putl1(i1,ib1,l1);
  }
  if(vvv&1) printf(" n1= %.15g n_ans= %.15g %s",(double)i2,(double)numans,sclock(~0l));
  return(i2);}
#endif

/* idee: l1 nach norm2 sortieren, um norm2 zu sparen */
#define N2Blen 1021  /* histogram size, prime number */
int     n2b[N2Blen]; /* histogram, hashed */
Tnorm2  n2h[N2Blen]; /* hash table, norm2 */

/* rough index into l1 should reduce cache misses if searching l1 (b2i) */
#define Nrough 1024 /* size for cached eough index */
tbase l1_rough_cfg[Nrough+1];

extern ULong x_max; /* ToDo: maximum number output xval.h => debug.h */
/* ----- initialize symmetric base (kfg-tables l1) v1.53 ----- */ 
/* ToDo: should be done with creation of l1 */
/* last change 08.04.1998 JS because of bug! */
void ini_norm2(void){  /* calculate orbit length or norm of each sym-config */
  volatile ULong i1;
  Tnorm2 sum2=0l,n2max=0; int i2, n2hash, n2num=0;
  tbase ib1;
  static struct sbase b1 /* b2=tmp */;
  STKa("ini_norm2",(unsigned long *)&i1); if(vvv&1)printf(" ini_norm2");
  b1.o=0;

  if(base2ok)F0("Fatal error, giving up.");
  
  err_pg(-1); /* reset errno for ERR(600) */
  for(i1=0l; i1<N2Blen; i1++) n2h[i1]=n2b[i1]=0; /* initialize hash table */
  for(i2=0;i2<Nrough;i2++)
     l1_rough_cfg[i2] = getl1(n1/Nrough*i2);
  l1_rough_cfg[Nrough]= getl1(n1-1);

  /* if (norm2) */
  for(i1=0l; i1<n1; i1++){  /* l1[] sort for norm2[]??? */
   ib1=getl1((ULong)i1);

   b_ifsmallest3(ib1,&b1); sum2+=b1.norm2; /* sum2 == numconf ! */
   if(b1.norm2 > n2max) n2max=b1.norm2;	/* store maximum orbit length */

   n2hash=(int)(((ULLong)b1.norm2)%N2Blen);
   if (!n2b[n2hash]) { n2b[n2hash]++; n2h[n2hash]=b1.norm2; n2num++; }
              else if (n2h[n2hash]==b1.norm2) n2b[n2hash]++;
              else { n2b[0]++; /* collision */}

   if (norm2){
     norm2[i1]=(ATnorm2)b1.norm2;
     if (((ATnorm2)b1.norm2)!=b1.norm2) 
     { ERR(600);norm2=(ATnorm2 *)myfree((void *)norm2, &m_n2); }
   }  
  }
  if (vvv) {
    printf("\n orbit lengths (norm2): ");
    for(i1=1; i1<N2Blen; i1++) if (n2b[i1])
      printf("\n norm2= %15.10g %8d times",(double)n2h[i1],n2b[i1]);
    if (n2b[0]) printf("\n hash_collisions= %8d (should be zero)",n2b[0]);
  }

  printf("\n n2num= %d  n2max= %.10g",n2num,(double)n2max);

  /* does not work for Tnorm2 == double */
  if ( ((ULLong)n2max) >> (sizeof(ATnorm2)/2*8) == 0 )
    printf("\n# spare memory: Change ATnorm2 to short or char.\n");
  if (norm2) { if(!sum2)F0("sum_norm2==0"); base2ok=1; }
  if (vvv&1) printf(" sum_norm2= %.15g",(double)sum2);
  if(vvv&1)printf(" %s",sclock(~0l));

  if (vvv&128) {
    printf("\nini_norm2 vvv&128:");
    for(i1=0l;i1<n1 && i1<x_max;i1++){	/* show base for debugging purpose */
      b_ifsmallest3(getl1((ULong)i1),&b1); /* different results for S>=1 */
      printf("\n %6d",(int)b1.norm2);
 /*     b_smallest(getl1((ULong)i1),&b1); *
  *     printf(  " %6d",(int)b1.norm2);   */
      b_getbase(getl1((ULong)i1),&b1);
      printf(  " %6d |%.15g>=",(int)b1.norm2,(double)i1);
      for(i2=0l;i2<b1.num;i2++) 
        printf("\n %32s*%s",outphase(b1.is[i2]),ckfg(b1.ib[i2]));
    }
  }
  STKe();return;
}


/* last modifications: 
   1998-148 type tbase j,m substituted by ulong etc.
   Dez98: general tbase-type independent b2i-fkt. + better errorhandling
 */

/* convert base to index, this is good break point for debugging */
ULong b2i_if_err(tbase i){	/* called if error in b2i() occurs */
  ULong j,m; static int err=0; static ULong m2=1l;
#ifdef SBase
  static struct sbase b; /* static makes it 100x faster, only used if error */
#endif /* SBase */
  while ((m2<<1)<n1) m2<<=1;	/* Feb00 */
  for(j=0l,m=m2;m;m>>=1){if((j|m)<n1)if( (getl1(j|m)<=i) )j|=m;}
  if (getl1(j)==i) return j;
  {			/* not found */
   if (++err<5) printf("\n b2i():   %s not found",ckfg(i));
#if defined(SBase)
   b.o=0;
   b_smallest(i,&b);if(err<5)printf("\n kfg_sm = %s phase= %s",ckfg(b.skfg),outphase(b.sign));
   b_getbase( i,&b);if(err<5)printf("\n kfg_gb = %s phase= %s",ckfg(b.skfg),outphase(b.sign));
   i=b.skfg;
#endif
   for(j=0l,m=m2;m;m>>=1){ if((j|m)<n1)if((getl1(j|m)<=i))j|=m; }
   if(!(getl1(j)==i)){       /* not found again !!! */
     if(err<3){
       if(j  >(ULong)0) printf("\nl1[%5lu]=%s",0l,ckfg(getl1(0l)));
       if(j  >(ULong)1) printf("\nl1[%5lu]=%s",1l,ckfg(getl1(1l)));
       if(j-2<n1) printf("\nl1[%5lu]=%s",j-2,ckfg(getl1(j-2)));
       if(j-1<n1) printf("\nl1[%5lu]=%s",j-1,ckfg(getl1(j-1)));
       if(j  <n1) printf("\nl1[%5lu]=%s",j  ,ckfg(getl1(j  )));
       if(j+1<n1) printf("\nl1[%5lu]=%s",j+1,ckfg(getl1(j+1)));
       ERR(400); 
     }
     for(j=0;j<n1;j++)if(getl1(j)==i) break; /* l1 not sorted? */
     if(j==n1)if(err<10){ ERR(410); err_fatal++; }
   }
   if (err<5) printf("\n now b2i() is ok and returns %lu",(unsigned long)j);
  }
  return(j);}

/* the routine is short as possible to fit into the cache
   input is spin-configuration (representator)
   output is index to tables
   ToDo:
    - convert more than one index within one call  for better cach performance
    - take 8 highest 8bit as index
     l1_rough_idx[i2+1]= i1;     # store highest index + 1?
    4opteron 32+8 sh=13s i55=55s   12zizj=1m32s 12sisj=4m07s v2.25  # odin2
    1opteron 32+8 sh=39s i55=1m29s 12zizj=2m22s 12sisj=11m42s v2.25
    replace bit trying by interval nesting
    1opteron 32+8 sh=39s i55=1m26s 12zizj=2m13s 12sisj=11m17s v2.26p1
    1opteron 32+8 sh=37s i55=1m26s 12zizj=2m16s 12sisj=11m25s v2.26p2 slower?
    4opteron 32+8 sh=11s i55=36s   12zizj=56s   12sisj=3m26s
    bei hohem Sz kein effekt da alle konfigs mit b00000000 beginnen?
     -8.22686824 2S= 24.000 -3e-14 
      i-j  0 24 SiSj  0.211689  SiSj-3ZiZj= -0.056100 -6e-02 num=   40
      
 */
ULong b2i(tbase i){
#if 1
  ULong j,ja,jb;
  j=ja=0; jb=Nrough; /* first search in cpu-cacheable rough table */
  for (;ja<jb;) { j=(ja+jb+1)/2; if (l1_rough_cfg[j]<=i) ja=j; else j=jb=j-1; }
  ja=n1/Nrough*j;
  jb=n1/Nrough*(j+1); if ((j+1)>=Nrough) jb=n1-1;
  j=ja; /* now search part of l1 */
  for (;ja<jb;) { j=(ja+jb+1)/2; if (getl1(j)<=i) ja=j; else j=jb=j-1; }
#else /* old version has lot of cpu-cache misses */
  ULong j,m; static ULong m2=1l;
  while ((m2<<1)<n1) m2<<=1;	/* Feb00 */
  for(j=0l,m=m2;;){if((j|m)<n1)if(getl1(j|m)<=i)j|=m;if(!(m>>=1))break;}
#endif
  if (getl1(j)==i) return j;
#if !defined(DEBUG)
  return n1;
#else
  return b2i_if_err(i); /* slow error-routine outside the cpu-i-cache */
#endif
}

